Index: trunk/source/App/TAppEncoder/TAppEncTop.cpp
===================================================================
--- trunk/source/App/TAppEncoder/TAppEncTop.cpp	(revision 443)
+++ trunk/source/App/TAppEncoder/TAppEncTop.cpp	(revision 608)
@@ -760,131 +519,82 @@
       AOT(true);
     }
-#if LGE_WVSO_A0119 
-    for ( Int iViewNum = 0; iViewNum < m_iNumberOfViews; iViewNum++ )
-    {
-      for (Int iContent = 0; iContent < 2; iContent++ )
-      {
-        TEncTop* pcEncTop = ( iContent == 0 ) ? m_acTEncTopList[iViewNum] : m_acTEncDepthTopList[iViewNum]; 
-        pcEncTop->setUseWVSO  ( m_bUseWVSO );
-        pcEncTop->setVSOWeight( m_iVSOWeight );
-        pcEncTop->setVSDWeight( m_iVSDWeight );
-        pcEncTop->setDWeight  ( m_iDWeight );
-      }
-    }
-#endif
-  }
-#endif
-
-#if HHI_INTERVIEW_SKIP
-  m_cUsedPelsRenderer.init(m_iSourceWidth, m_iSourceHeight, true, 0, LOG2_DISP_PREC_LUT, true, 0, 0, 0, 0, 0, 6, 4, 1, 0, 6 );
-#endif
-
+  }
+#endif
 }
 
 Void TAppEncTop::xCreateLib()
 {
-  for(Int iViewIdx=0; iViewIdx<m_iNumberOfViews; iViewIdx++)
-  {
-    m_acTVideoIOYuvInputFileList[iViewIdx]->open( m_pchInputFileList[iViewIdx],     false, m_uiInputBitDepth, m_uiInternalBitDepth );  // read  mode
-    m_acTVideoIOYuvInputFileList[iViewIdx]->skipFrames(m_FrameSkip, m_iSourceWidth - m_aiPad[0], m_iSourceHeight - m_aiPad[1]);
-
-    if (m_pchReconFileList[iViewIdx])
-      m_acTVideoIOYuvReconFileList[iViewIdx]->open(m_pchReconFileList[iViewIdx], true, m_uiOutputBitDepth, m_uiInternalBitDepth);  // write mode
-    m_acTEncTopList[iViewIdx]->create();
-    if( m_bUsingDepthMaps )
-    {
-      m_acTVideoIOYuvDepthInputFileList[iViewIdx]->open( m_pchDepthInputFileList[iViewIdx],     false, m_uiInputBitDepth, m_uiInternalBitDepth );  // read  mode
-      m_acTVideoIOYuvDepthInputFileList[iViewIdx]->skipFrames(m_FrameSkip, m_iSourceWidth - m_aiPad[0], m_iSourceHeight - m_aiPad[1]);
-
-      if (m_pchDepthReconFileList[iViewIdx])
-        m_acTVideoIOYuvDepthReconFileList[iViewIdx]->open(m_pchDepthReconFileList[iViewIdx], true, m_uiOutputBitDepth, m_uiInternalBitDepth);  // write mode
-      m_acTEncDepthTopList[iViewIdx]->create();
-    }
-#if H3D_IVMP
-    else if( m_uiMultiviewMvRegMode )
-    {
-      m_acTVideoIOYuvDepthInputFileList[iViewIdx]->open( m_pchDepthInputFileList[iViewIdx],     false, m_uiInputBitDepth, m_uiInternalBitDepth );  // read  mode
-      m_acTVideoIOYuvDepthInputFileList[iViewIdx]->skipFrames(m_FrameSkip, m_iSourceWidth, m_iSourceHeight);
-    }
-#endif
-  }
+#if H_MV
+  // initialize global variables
+  initROM();
+#if H_3D_DIM_DMM
+  initWedgeLists( true );
+#endif
+
+  for( Int layer=0; layer < m_numberOfLayers; layer++)
+  {
+    m_acTVideoIOYuvInputFileList[layer]->open( m_pchInputFileList[layer],     false, m_inputBitDepthY, m_inputBitDepthC, m_internalBitDepthY, m_internalBitDepthC );  // read  mode
+    m_acTVideoIOYuvInputFileList[layer]->skipFrames( m_FrameSkip, m_iSourceWidth - m_aiPad[0], m_iSourceHeight - m_aiPad[1]);
+
+    if (m_pchReconFileList[layer])
+    {
+      m_acTVideoIOYuvReconFileList[layer]->open( m_pchReconFileList[layer], true, m_outputBitDepthY, m_outputBitDepthC, m_internalBitDepthY, m_internalBitDepthC);  // write mode
+    }
+    m_acTEncTopList[layer]->create();
+  }
+#else
+  // Video I/O
+  m_cTVideoIOYuvInputFile.open( m_pchInputFile,     false, m_inputBitDepthY, m_inputBitDepthC, m_internalBitDepthY, m_internalBitDepthC );  // read  mode
+  m_cTVideoIOYuvInputFile.skipFrames(m_FrameSkip, m_iSourceWidth - m_aiPad[0], m_iSourceHeight - m_aiPad[1]);
+
+  if (m_pchReconFile)
+    m_cTVideoIOYuvReconFile.open(m_pchReconFile, true, m_outputBitDepthY, m_outputBitDepthC, m_internalBitDepthY, m_internalBitDepthC);  // write mode
+  
+  // Neo Decoder
+  m_cTEncTop.create();
+#endif
 }
 
 Void TAppEncTop::xDestroyLib()
 {
+#if H_MV
+  // destroy ROM
+  destroyROM();
+
+  for(Int layer=0; layer<m_numberOfLayers; layer++)
+  {
+    m_acTVideoIOYuvInputFileList[layer]->close();
+    m_acTVideoIOYuvReconFileList[layer]->close();
+    delete m_acTVideoIOYuvInputFileList[layer] ; 
+    m_acTVideoIOYuvInputFileList[layer] = NULL;
+    delete m_acTVideoIOYuvReconFileList[layer] ; 
+    m_acTVideoIOYuvReconFileList[layer] = NULL;
+    m_acTEncTopList[layer]->deletePicBuffer();
+    m_acTEncTopList[layer]->destroy();
+    delete m_acTEncTopList[layer] ; 
+    m_acTEncTopList[layer] = NULL;
+    delete m_picYuvRec[layer] ; 
+    m_picYuvRec[layer] = NULL;
+  }
+#else
   // Video I/O
-  for(Int iViewIdx=0; iViewIdx<m_iNumberOfViews; iViewIdx++)
-  {
-    m_acTVideoIOYuvInputFileList[iViewIdx]->close();
-    m_acTVideoIOYuvReconFileList[iViewIdx]->close();
-    delete m_acTVideoIOYuvInputFileList[iViewIdx] ; 
-    m_acTVideoIOYuvInputFileList[iViewIdx] = NULL;
-    delete m_acTVideoIOYuvReconFileList[iViewIdx] ; 
-    m_acTVideoIOYuvReconFileList[iViewIdx] = NULL;
-    m_acTEncTopList[iViewIdx]->deletePicBuffer();
-    m_acTEncTopList[iViewIdx]->destroy();
-    delete m_acTEncTopList[iViewIdx] ; 
-    m_acTEncTopList[iViewIdx] = NULL;
-    delete m_picYuvRec[iViewIdx] ; 
-    m_picYuvRec[iViewIdx] = NULL;
-
-    if( iViewIdx < Int( m_acTVideoIOYuvDepthInputFileList.size() ) && m_acTVideoIOYuvDepthInputFileList[iViewIdx] )
-    {
-      m_acTVideoIOYuvDepthInputFileList[iViewIdx]->close( );
-      delete m_acTVideoIOYuvDepthInputFileList[iViewIdx];
-      m_acTVideoIOYuvDepthInputFileList[iViewIdx] = NULL;
-    }
-    if( iViewIdx < Int( m_acTVideoIOYuvDepthReconFileList.size() ) && m_acTVideoIOYuvDepthReconFileList[iViewIdx] )
-    {
-      m_acTVideoIOYuvDepthReconFileList[iViewIdx]->close () ;
-      delete m_acTVideoIOYuvDepthReconFileList[iViewIdx];
-      m_acTVideoIOYuvDepthReconFileList[iViewIdx] = NULL;
-    }
-    if( iViewIdx < Int( m_acTEncDepthTopList.size() ) && m_acTEncDepthTopList[iViewIdx] )
-    {
-      m_acTEncDepthTopList[iViewIdx]->deletePicBuffer();
-      m_acTEncDepthTopList[iViewIdx]->destroy();
-      delete m_acTEncDepthTopList[iViewIdx];
-      m_acTEncDepthTopList[iViewIdx] = NULL;
-    }
-    if( iViewIdx < Int( m_picYuvDepthRec.size() ) && m_picYuvDepthRec[iViewIdx] )
-    {
-      delete m_picYuvDepthRec[iViewIdx] ; 
-      m_picYuvDepthRec[iViewIdx] = NULL;
-    }
-  }
+  m_cTVideoIOYuvInputFile.close();
+  m_cTVideoIOYuvReconFile.close();
+  
+  // Neo Decoder
+  m_cTEncTop.destroy();
+#endif
 }
 
 Void TAppEncTop::xInitLib()
 {
-  for(Int iViewIdx=0; iViewIdx<m_iNumberOfViews; iViewIdx++)
-  {
-    m_acTEncTopList[iViewIdx]->init( this );
-#if QC_MVHEVC_B0046
-  //set setNumDirectRefLayer
-  Int iNumDirectRef = m_acTEncTopList[iViewIdx]->getSPS()->getNumberOfUsableInterViewRefs();
-  m_acTEncTopList[iViewIdx]->getEncTop()->getVPS()->setNumDirectRefLayer(iNumDirectRef, iViewIdx);
-  for(Int iNumIvRef = 0; iNumIvRef < iNumDirectRef; iNumIvRef ++)
-  {
-    Int iLayerId = m_acTEncTopList[iViewIdx]->getSPS()->getUsableInterViewRef(iNumIvRef);
-    m_acTEncTopList[iViewIdx]->getEncTop()->getVPS()->setDirectRefLayerId( iLayerId + iViewIdx, iViewIdx, iNumIvRef);
-  }
-#endif
-  }
-  for(Int iViewIdx=0; iViewIdx<m_iNumberOfViews; iViewIdx++)
-  {
-    m_acTEncTopList[iViewIdx]->setTEncTopList( &m_acTEncTopList  );
-  }
-  if ( m_bUsingDepthMaps )
-  {
-    for(Int iViewIdx=0; iViewIdx<m_iNumberOfViews; iViewIdx++)
-    {
-      m_acTEncDepthTopList[iViewIdx]->init( this );
-    }
-    for(Int iViewIdx=0; iViewIdx<m_iNumberOfViews; iViewIdx++)
-    {
-      m_acTEncDepthTopList[iViewIdx]->setTEncTopList( &m_acTEncDepthTopList  );
-    }
-  }
+#if H_MV
+  for(Int layer=0; layer<m_numberOfLayers; layer++)
+  {
+    m_acTEncTopList[layer]->init( );
+  }
+#else
+  m_cTEncTop.init();
+#endif
 }
 
@@ -911,11 +621,6 @@
 
   TComPicYuv*       pcPicYuvOrg = new TComPicYuv;
-  TComPicYuv*       pcDepthPicYuvOrg = new TComPicYuv;
-#if !QC_MVHEVC_B0046
-  TComPicYuv*       pcPdmDepthOrg    = new TComPicYuv;
-#endif
   TComPicYuv*       pcPicYuvRec = NULL;
-  TComPicYuv*       pcDepthPicYuvRec = NULL;
-
+  
   // initialize internal class & member variables
   xInitLibCfg();
@@ -924,89 +629,58 @@
   
   // main encoder loop
+#if H_MV
   Bool  allEos = false;
   std::vector<Bool>  eos ;
-  std::vector<Bool>  depthEos ;
+  std::vector<Bool>  flush ;  
+  
+  Int gopSize    = 1;
   Int maxGopSize = 0;
-  Int gopSize = 1;
-  
+  maxGopSize = (std::max)(maxGopSize, m_acTEncTopList[0]->getGOPSize());  
+  
+  for(Int layer=0; layer < m_numberOfLayers; layer++ )
+  {
+    eos  .push_back( false );
+    flush.push_back( false );
+  }
+#else
+  Int   iNumEncoded = 0;
+  Bool  bEos = false;
+#endif
+ 
   list<AccessUnit> outputAccessUnits; ///< list of access units to write out.  is populated by the encoding process
-  maxGopSize = (std::max)(maxGopSize, m_acTEncTopList[0]->getGOPSize());   
-
-  for(Int iViewIdx=0; iViewIdx < m_iNumberOfViews; iViewIdx++ )
-  {
-    eos.push_back( false );
-    depthEos.push_back( false );
-    
-#if RWTH_SDC_DLT_B0036
-    if( m_bUsingDepthMaps && m_bUseDLT )
-      xAnalyzeInputBaseDepth(iViewIdx, m_iIntraPeriod);
-#endif
-  }
 
   // allocate original YUV buffer
   pcPicYuvOrg->create( m_iSourceWidth, m_iSourceHeight, m_uiMaxCUWidth, m_uiMaxCUHeight, m_uiMaxCUDepth );
-  pcDepthPicYuvOrg->create( m_iSourceWidth, m_iSourceHeight, m_uiMaxCUWidth, m_uiMaxCUHeight, m_uiMaxCUDepth );
-
-#if H3D_IVMP
-  if( m_uiMultiviewMvRegMode )
-  {
-    pcPdmDepthOrg->create( m_iSourceWidth, m_iSourceHeight, m_uiMaxCUWidth, m_uiMaxCUHeight, m_uiMaxCUDepth );
-  }
-#endif
-
+  
+#if H_MV
   while ( !allEos )
   {
-    for(Int iViewIdx=0; iViewIdx < m_iNumberOfViews; iViewIdx++ )
+    for(Int layer=0; layer < m_numberOfLayers; layer++ )
     {
       Int frmCnt = 0;
-      while ( !eos[iViewIdx] && !(frmCnt == gopSize))
+      while ( !eos[layer] && !(frmCnt == gopSize))
       {
         // get buffers
-        xGetBuffer(pcPicYuvRec, iViewIdx, false);
+        xGetBuffer(pcPicYuvRec, layer);
 
         // read input YUV file
-        m_acTVideoIOYuvInputFileList[iViewIdx]->read( pcPicYuvOrg, m_aiPad );
-      
-#if H3D_IVMP
-        if( m_uiMultiviewMvRegMode && iViewIdx )
+        m_acTVideoIOYuvInputFileList[layer]->read      ( pcPicYuvOrg, m_aiPad );
+        m_acTEncTopList             [layer]->initNewPic( pcPicYuvOrg );
+
+        // increase number of received frames
+        m_frameRcvd[layer]++;
+        
+        frmCnt++;
+
+        eos[layer] = (m_frameRcvd[layer] == m_framesToBeEncoded);
+        allEos = allEos||eos[layer];
+
+        // if end of file (which is only detected on a read failure) flush the encoder of any queued pictures
+        if (m_acTVideoIOYuvInputFileList[layer]->isEof())
         {
-          m_acTVideoIOYuvDepthInputFileList[iViewIdx]->read( pcPdmDepthOrg, m_aiPad, m_bUsingDepthMaps );
-        }
-#endif
-
-#if H3D_IVMP
-        m_acTEncTopList[iViewIdx]->initNewPic( pcPicYuvOrg, ( m_uiMultiviewMvRegMode && iViewIdx ? pcPdmDepthOrg : 0 ) );
-#else
-        m_acTEncTopList[iViewIdx]->initNewPic( pcPicYuvOrg );
-#endif
-
-        // increase number of received frames
-        m_frameRcvd[iViewIdx]++;
-        frmCnt++;
-        // check end of file
-        eos[iViewIdx] = ( m_acTVideoIOYuvInputFileList[iViewIdx]->isEof() == 1 ?   true : false  );
-        eos[iViewIdx] = ( m_frameRcvd[iViewIdx] == m_iFrameToBeEncoded ?    true : eos[iViewIdx]   );
-        allEos = allEos|eos[iViewIdx] ; 
-      }
-      if( m_bUsingDepthMaps )
-      {
-        Int frmCntDepth = 0;
-        while ( !depthEos[iViewIdx] && !(frmCntDepth == gopSize))
-        {
-          // get buffers
-          xGetBuffer(pcDepthPicYuvRec, iViewIdx, true);
-
-          // read input YUV file
-          m_acTVideoIOYuvDepthInputFileList[iViewIdx]->read( pcDepthPicYuvOrg, m_aiPad );
-
-          m_acTEncDepthTopList[iViewIdx]->initNewPic( pcDepthPicYuvOrg );
-
-          // increase number of received frames
-          m_depthFrameRcvd[iViewIdx]++;
-          frmCntDepth++;
-          // check end of file
-          depthEos[iViewIdx] = ( m_acTVideoIOYuvDepthInputFileList[iViewIdx]->isEof() == 1 ?   true : false  );
-          depthEos[iViewIdx] = ( m_depthFrameRcvd[iViewIdx] == m_iFrameToBeEncoded ?    true : depthEos[iViewIdx]   );
-          allEos = allEos|depthEos[iViewIdx] ; 
+          flush          [layer] = true;
+          eos            [layer] = true;
+          m_frameRcvd    [layer]--;
+          m_acTEncTopList[layer]->setFramesToBeEncoded(m_frameRcvd[layer]);
         }
       }
@@ -1014,245 +688,99 @@
     for ( Int gopId=0; gopId < gopSize; gopId++ )
     {
-      Int  iNumEncoded = 0;
-
-#if !QC_MVHEVC_B0046
+#if H_3D
       UInt iNextPoc = m_acTEncTopList[0] -> getFrameId( gopId );
-      if ( iNextPoc < m_iFrameToBeEncoded )
+      if ( iNextPoc < m_framesToBeEncoded )
       {
         m_cCameraData.update( iNextPoc );
       }
 #endif
-
-
-#if FLEX_CODING_ORDER_M23723
-      if (m_b3DVFlexOrder)
+      for(Int layer=0; layer < m_numberOfLayers; layer++ )
       {
-        Int  iNumDepthEncoded = 0;
-        iNumEncoded = 0;
-        Int i=0;
-        Int iViewIdx=0;
-        Int iNumberofDepthViews = m_bUsingDepthMaps?m_iNumberOfViews:0;
-        for (Int j=0; j < (m_iNumberOfViews+ iNumberofDepthViews); j++ )
-        {
-          if (m_pchMVCJointCodingOrder[i]=='T')
+#if H_3D_VSO        
+          if( m_bUseVSO && m_bUseEstimatedVSD && iNextPoc < m_framesToBeEncoded )
           {
-
-            i++;
-            assert(isdigit(m_pchMVCJointCodingOrder[i]));
-            iViewIdx = (Int)(m_pchMVCJointCodingOrder[i]-'0');
-#if (FCO_FIX && MERL_VSP_C0152)
-            Int iCurPoc = m_acTEncTopList[iViewIdx]->getFrameId(gopId);
-            if( iCurPoc < m_acTEncTopList[iViewIdx]->getFrameToBeEncoded() && iViewIdx!=0 )
-            {
-              TComPic* pcBaseTxtPic   = getPicFromView(  0, m_acTEncTopList[iViewIdx]->getFrameId(gopId), false ); //get base view reconstructed texture
-              TComPic* pcBaseDepthPic = getPicFromView(  0, m_acTEncTopList[iViewIdx]->getFrameId(gopId), true );  //get base view reconstructed depth
-              TEncSlice* pEncSlice = m_acTEncTopList[iViewIdx]->getSliceEncoder();
-              pEncSlice->setRefPicBaseTxt(pcBaseTxtPic);
-              pEncSlice->setRefPicBaseDepth(pcBaseDepthPic);
-            }
-            setBWVSPLUT( iViewIdx, gopId, false);            
-#endif
-
-            m_acTEncTopList[iViewIdx]->encode( eos[iViewIdx], pcPicYuvOrg, *m_picYuvRec[iViewIdx], outputAccessUnits, iNumEncoded, gopId );
-            xWriteOutput(bitstreamFile, iNumEncoded, outputAccessUnits, iViewIdx, false);
-            outputAccessUnits.clear();
-            i++;
+            m_cCameraData.setDispCoeff( iNextPoc, m_acTEncTopList[layer]->getViewIndex() );
+            m_acTEncTopList[layer]  ->setDispCoeff( m_cCameraData.getDispCoeff() );
           }
-          else if ( m_pchMVCJointCodingOrder[i] == 'D')
-          {
-
-            i++;
-            if( m_bUsingDepthMaps )
-            {
-              assert(isdigit(m_pchMVCJointCodingOrder[i]));
-              iViewIdx = (Int)(m_pchMVCJointCodingOrder[i]-'0');
-
-#if SAIT_VSO_EST_A0033
-              if( m_bUseVSO && iNextPoc < m_iFrameToBeEncoded )
-              {
-                m_cCameraData.xSetDispCoeff( iNextPoc, iViewIdx );
-                m_acTEncDepthTopList[iViewIdx]->setDispCoeff( m_cCameraData.getDispCoeff() );
-              }
-#endif
-#if (FCO_FIX && MERL_VSP_C0152)
-              Int iCurPocDepth = m_acTEncDepthTopList[iViewIdx]->getFrameId(gopId);
-              if( iCurPocDepth < m_acTEncDepthTopList[iViewIdx]->getFrameToBeEncoded() && iViewIdx!=0 )
-              {
-                TComPic* pcBaseDepthPic = getPicFromView(  0, m_acTEncDepthTopList[iViewIdx]->getFrameId(gopId), true );
-                TEncSlice* pcSlice = (TEncSlice*) m_acTEncDepthTopList[iViewIdx]->getSliceEncoder();
-                pcSlice->setRefPicBaseDepth(pcBaseDepthPic);
-              }
-              setBWVSPLUT( iViewIdx, gopId, true);
-#endif
-              m_acTEncDepthTopList[iViewIdx]->encode( depthEos[iViewIdx], pcDepthPicYuvOrg, *m_picYuvDepthRec[iViewIdx], outputAccessUnits, iNumDepthEncoded, gopId );
-              xWriteOutput(bitstreamFile, iNumDepthEncoded, outputAccessUnits, iViewIdx, true);
-              outputAccessUnits.clear();
-              i++;
-            }
-          }
-        }
+#endif
+        Int   iNumEncoded = 0;
+
+        // call encoding function for one frame          
+        m_acTEncTopList[layer]->encode( eos[layer], flush[layer] ? 0 : pcPicYuvOrg, *m_picYuvRec[layer], outputAccessUnits, iNumEncoded, gopId );        
+        xWriteOutput(bitstreamFile, iNumEncoded, outputAccessUnits, layer);
+        outputAccessUnits.clear();
       }
-      else
-      {
-
-#endif
-      for(Int iViewIdx=0; iViewIdx < m_iNumberOfViews; iViewIdx++ )
-      {
-#if SAIT_VSO_EST_A0033
-        if( m_bUseVSO && iNextPoc < m_iFrameToBeEncoded )
-        {
-          m_cCameraData.xSetDispCoeff( iNextPoc, iViewIdx );
-          m_acTEncDepthTopList[iViewIdx]->setDispCoeff( m_cCameraData.getDispCoeff() );
-        }
-#endif
-        iNumEncoded = 0;
-
-#if MERL_VSP_C0152
-#if MERL_VSP_C0152_BugFix_ForNoDepthCase
-        if(m_bUsingDepthMaps) // VSP can be used only when depth is available as input
-        {
-#endif
-        Int iCurPoc = m_acTEncDepthTopList[iViewIdx]->getFrameId(gopId);
-        if( iCurPoc < m_acTEncDepthTopList[iViewIdx]->getFrameToBeEncoded() && iViewIdx!=0 )
-        {
-          TComPic* pcBaseTxtPic   = getPicFromView(  0, m_acTEncDepthTopList[iViewIdx]->getFrameId(gopId), false ); //get base view reconstructed texture
-          TComPic* pcBaseDepthPic = getPicFromView(  0, m_acTEncDepthTopList[iViewIdx]->getFrameId(gopId), true );  //get base view reconstructed depth
-          TEncSlice* pEncSlice = m_acTEncTopList[iViewIdx]->getSliceEncoder();
-          pEncSlice->setRefPicBaseTxt(pcBaseTxtPic);
-          pEncSlice->setRefPicBaseDepth(pcBaseDepthPic);
-#if MERL_VSP_NBDV_RefVId_Fix_D0166
-          for (Int refViewId=0; refViewId < iViewIdx; refViewId++ )
-          {
-            pEncSlice->setListDepthPic(m_acTEncDepthTopList[refViewId]->getListPic(), refViewId ); // The list will store only the depth pictures
-            setBWVSPLUT(refViewId, iViewIdx, gopId, false);
-          } 
-#endif
-        }
-#if !MERL_VSP_NBDV_RefVId_Fix_D0166
-        setBWVSPLUT( iViewIdx, gopId, false);
-#endif
-#endif
-
-#if MERL_VSP_C0152_BugFix_ForNoDepthCase
-        }
-        else
-        {
-          Int iCurPoc = m_acTEncTopList[iViewIdx]->getFrameId(gopId);
-          if( iCurPoc < m_acTEncTopList[iViewIdx]->getFrameToBeEncoded() && iViewIdx!=0 )
-          {
-            TEncSlice* pEncSlice = m_acTEncTopList[iViewIdx]->getSliceEncoder();
-            pEncSlice->setRefPicBaseTxt(NULL);//Initialize the base view reconstructed texture buffer
-            pEncSlice->setRefPicBaseDepth(NULL);//Initialize the base view reconstructed depth buffer
-          }
-        }
-#endif
-
-        // call encoding function for one frame
-        m_acTEncTopList[iViewIdx]->encode( eos[iViewIdx], pcPicYuvOrg, *m_picYuvRec[iViewIdx], outputAccessUnits, iNumEncoded, gopId );
-        xWriteOutput(bitstreamFile, iNumEncoded, outputAccessUnits, iViewIdx, false);
-        outputAccessUnits.clear();
-        if( m_bUsingDepthMaps )
-        {
-          Int  iNumDepthEncoded = 0;
-#if MERL_VSP_C0152
-        Int iCurPocDepth = m_acTEncDepthTopList[iViewIdx]->getFrameId(gopId);
-        if( iCurPocDepth < m_acTEncDepthTopList[iViewIdx]->getFrameToBeEncoded() && iViewIdx!=0 )
-        {
-          TComPic* pcBaseDepthPic = getPicFromView(  0, m_acTEncDepthTopList[iViewIdx]->getFrameId(gopId), true );
-          TEncSlice* pcSlice = (TEncSlice*) m_acTEncDepthTopList[iViewIdx]->getSliceEncoder();
-          pcSlice->setRefPicBaseDepth(pcBaseDepthPic);
-#if  MERL_VSP_NBDV_RefVId_Fix_D0166
-          for (Int refViewId=0; refViewId < iViewIdx; refViewId++ )
-          {
-            pcSlice->setListDepthPic(m_acTEncDepthTopList[refViewId]->getListPic(), refViewId ); // The list will store only the depth pictures
-            setBWVSPLUT( refViewId, iViewIdx, gopId, true);
-          } 
-#endif
-        }
-#if !MERL_VSP_NBDV_RefVId_Fix_D0166
-        setBWVSPLUT( iViewIdx, gopId, true);
-#endif
-#endif
-
-          // call encoding function for one depth frame
-          m_acTEncDepthTopList[iViewIdx]->encode( depthEos[iViewIdx], pcDepthPicYuvOrg, *m_picYuvDepthRec[iViewIdx], outputAccessUnits, iNumDepthEncoded, gopId );
-          xWriteOutput(bitstreamFile, iNumDepthEncoded, outputAccessUnits, iViewIdx, true);
-          outputAccessUnits.clear();
-        }
-      }
- 
-#if FLEX_CODING_ORDER_M23723
-      }
-#endif
-
-#if HHI_INTERVIEW_SKIP || H3D_IVMP || H3D_IVRP
-      for( Int iViewIdx = 0; iViewIdx < m_iNumberOfViews; iViewIdx++ )
-      {
-        if( iViewIdx < (Int)m_acTEncTopList.size() && m_acTEncTopList[iViewIdx] )
-        {
-          m_acTEncTopList[iViewIdx]->deleteExtraPicBuffers( m_acTEncTopList[iViewIdx]->getGOPEncoder()->getPocLastCoded() );
-        }
-        if( iViewIdx < (Int)m_acTEncDepthTopList.size() && m_acTEncDepthTopList[iViewIdx] )
-        {
-          m_acTEncDepthTopList[iViewIdx]->deleteExtraPicBuffers( m_acTEncTopList[iViewIdx]->getGOPEncoder()->getPocLastCoded() );
-        }
-      }
-#endif
-      for(Int iViewIdx=0; iViewIdx < m_iNumberOfViews; iViewIdx++ )
-      {
-        m_acTEncTopList[iViewIdx]->compressMotion( m_acTEncTopList[iViewIdx]->getGOPEncoder()->getPocLastCoded() );
-        if( m_bUsingDepthMaps )
-        {
-          m_acTEncDepthTopList[iViewIdx]->compressMotion( m_acTEncDepthTopList[iViewIdx]->getGOPEncoder()->getPocLastCoded() );
-        }
-      }
     }
     gopSize = maxGopSize;
   }
+  for(Int layer=0; layer < m_numberOfLayers; layer++ )
+  {
+    m_acTEncTopList[layer]->printSummary( m_acTEncTopList[layer]->getNumAllPicCoded() );
+  }
+#else
+  while ( !bEos )
+  {
+    // get buffers
+    xGetBuffer(pcPicYuvRec);
+
+    // read input YUV file
+    m_cTVideoIOYuvInputFile.read( pcPicYuvOrg, m_aiPad );
+
+    // increase number of received frames
+    m_iFrameRcvd++;
+
+    bEos = (m_iFrameRcvd == m_framesToBeEncoded);
+
+    Bool flush = 0;
+    // if end of file (which is only detected on a read failure) flush the encoder of any queued pictures
+    if (m_cTVideoIOYuvInputFile.isEof())
+    {
+      flush = true;
+      bEos = true;
+      m_iFrameRcvd--;
+      m_cTEncTop.setFramesToBeEncoded(m_iFrameRcvd);
+    }
+
+    // call encoding function for one frame
+    m_cTEncTop.encode( bEos, flush ? 0 : pcPicYuvOrg, m_cListPicYuvRec, outputAccessUnits, iNumEncoded );
+    
+    // write bistream to file if necessary
+    if ( iNumEncoded > 0 )
+    {
+      xWriteOutput(bitstreamFile, iNumEncoded, outputAccessUnits);
+      outputAccessUnits.clear();
+    }
+  }
+
+  m_cTEncTop.printSummary();
+#endif
+
   // delete original YUV buffer
   pcPicYuvOrg->destroy();
   delete pcPicYuvOrg;
   pcPicYuvOrg = NULL;
-  pcDepthPicYuvOrg->destroy();
-  delete pcDepthPicYuvOrg;
-  pcDepthPicYuvOrg = NULL;
-  
-#if !QC_MVHEVC_B0046
-  if ( pcPdmDepthOrg != NULL && m_uiMultiviewMvRegMode )
-  {
-    pcPdmDepthOrg->destroy();
-    delete pcPdmDepthOrg;     
-    pcPdmDepthOrg = NULL; 
-  };
-#endif
-  
-  for(Int iViewIdx=0; iViewIdx < m_iNumberOfViews; iViewIdx++ )
-  {
-    m_acTEncTopList[iViewIdx]->printOutSummary(m_acTEncTopList[iViewIdx]->getNumAllPicCoded());
-    if ( m_bUsingDepthMaps )
-    {
-      m_acTEncDepthTopList[iViewIdx]->printOutSummary(m_acTEncDepthTopList[iViewIdx]->getNumAllPicCoded());
-    }
-  }
+  
+#if !H_MV
+  // delete used buffers in encoder class
+  m_cTEncTop.deletePicBuffer();
+#endif
 
   // delete buffers & classes
   xDeleteBuffer();
   xDestroyLib();
+  
+  printRateSummary();
+
+#if H_3D_REN_MAX_DEV_OUT
+  Double dMaxDispDiff = m_cCameraData.getMaxShiftDeviation(); 
+
+  if ( !(dMaxDispDiff < 0) )
+  {  
+    printf("\n Max. possible shift error: %12.3f samples.\n", dMaxDispDiff );
+  }
+#endif
 
   return;
 }
-
-TEncTop*  TAppEncTop::getTEncTop( Int viewId, Bool isDepth )    
-{ 
-  if ( isDepth )  
-  {
-    return m_acTEncDepthTopList[viewId]; 
-  } 
-  else
-  { 
-    return m_acTEncTopList[viewId]; 
-  } 
-}
-
 
 // ====================================================================================================================
@@ -1266,107 +794,97 @@
  .
  */
-Void TAppEncTop::xGetBuffer( TComPicYuv*& rpcPicYuvRec, Int iViewIdx, Bool isDepth)
+#if H_MV
+Void TAppEncTop::xGetBuffer( TComPicYuv*& rpcPicYuvRec, UInt layer)
+#else
+Void TAppEncTop::xGetBuffer( TComPicYuv*& rpcPicYuvRec)
+#endif
 {
   assert( m_iGOPSize > 0 );
   
-  if( !isDepth )
-  {
-    if ( m_picYuvRec[iViewIdx]->size() == (UInt)m_iGOPSize )
-    {
-      rpcPicYuvRec = m_picYuvRec[iViewIdx]->popFront();
-    }
-    else
-    {
-      rpcPicYuvRec = new TComPicYuv; 
-      rpcPicYuvRec->create( m_iSourceWidth, m_iSourceHeight, m_uiMaxCUWidth, m_uiMaxCUHeight, m_uiMaxCUDepth );
-    }
-    m_picYuvRec[iViewIdx]->pushBack( rpcPicYuvRec );
+  // org. buffer
+#if H_MV
+  if ( m_picYuvRec[layer]->size() == (UInt)m_iGOPSize )
+  {
+    rpcPicYuvRec = m_picYuvRec[layer]->popFront();
+#else
+  if ( m_cListPicYuvRec.size() == (UInt)m_iGOPSize )
+  {
+    rpcPicYuvRec = m_cListPicYuvRec.popFront();
+#endif
+
   }
   else
   {
-    if ( m_picYuvDepthRec[iViewIdx]->size() == (UInt)m_iGOPSize )
-    {
-      rpcPicYuvRec = m_picYuvDepthRec[iViewIdx]->popFront();
-    }
-    else
-    {
-      rpcPicYuvRec = new TComPicYuv; 
-      rpcPicYuvRec->create( m_iSourceWidth, m_iSourceHeight, m_uiMaxCUWidth, m_uiMaxCUHeight, m_uiMaxCUDepth );
-    }
-    m_picYuvDepthRec[iViewIdx]->pushBack( rpcPicYuvRec );
-  }
+    rpcPicYuvRec = new TComPicYuv;
+    
+    rpcPicYuvRec->create( m_iSourceWidth, m_iSourceHeight, m_uiMaxCUWidth, m_uiMaxCUHeight, m_uiMaxCUDepth );
+
+  }
+#if H_MV
+  m_picYuvRec[layer]->pushBack( rpcPicYuvRec );
+#else
+  m_cListPicYuvRec.pushBack( rpcPicYuvRec );
+#endif
 }
 
 Void TAppEncTop::xDeleteBuffer( )
 {
-  for(Int iViewIdx=0; iViewIdx<m_picYuvRec.size(); iViewIdx++)
-  {
-    if(m_picYuvRec[iViewIdx])
-    {
-      TComList<TComPicYuv*>::iterator iterPicYuvRec  = m_picYuvRec[iViewIdx]->begin();
-      Int iSize = Int( m_picYuvRec[iViewIdx]->size() );
-      for ( Int i = 0; i < iSize; i++ )
-      {
-        TComPicYuv*  pcPicYuvRec  = *(iterPicYuvRec++);
-        if(pcPicYuvRec)
-        {
-          pcPicYuvRec->destroy();
-          delete pcPicYuvRec; 
-          pcPicYuvRec = NULL;
-        }
-      }
-    } 
-  }
-  for(Int iViewIdx=0; iViewIdx<m_picYuvDepthRec.size(); iViewIdx++)
-  {
-    if(m_picYuvDepthRec[iViewIdx])
-    {
-      TComList<TComPicYuv*>::iterator iterPicYuvRec  = m_picYuvDepthRec[iViewIdx]->begin();
-      Int iSize = Int( m_picYuvDepthRec[iViewIdx]->size() );
-      for ( Int i = 0; i < iSize; i++ )
-      {
-        TComPicYuv*  pcPicYuvRec  = *(iterPicYuvRec++);
-        if(pcPicYuvRec)
-        {
-          pcPicYuvRec->destroy();
-          delete pcPicYuvRec; 
-          pcPicYuvRec = NULL;
-        }
-      } 
-    }
-  }
+#if H_MV
+  for(Int layer=0; layer<m_picYuvRec.size(); layer++)
+  {
+    if(m_picYuvRec[layer])
+    {
+      TComList<TComPicYuv*>::iterator iterPicYuvRec  = m_picYuvRec[layer]->begin();
+      Int iSize = Int( m_picYuvRec[layer]->size() );
+#else
+  TComList<TComPicYuv*>::iterator iterPicYuvRec  = m_cListPicYuvRec.begin();
+  
+  Int iSize = Int( m_cListPicYuvRec.size() );
+#endif
+
+  for ( Int i = 0; i < iSize; i++ )
+  {
+    TComPicYuv*  pcPicYuvRec  = *(iterPicYuvRec++);
+    pcPicYuvRec->destroy();
+    delete pcPicYuvRec; pcPicYuvRec = NULL;
+  }
+
+#if H_MV
+    }
+  }
+#endif  
 }
 
 /** \param iNumEncoded  number of encoded frames
  */
-Void TAppEncTop::xWriteOutput(std::ostream& bitstreamFile, Int iNumEncoded, std::list<AccessUnit>& accessUnits, Int iViewIdx, Bool isDepth )
+#if H_MV
+Void TAppEncTop::xWriteOutput(std::ostream& bitstreamFile, Int iNumEncoded, std::list<AccessUnit>& accessUnits, UInt layerId)
+#else
+Void TAppEncTop::xWriteOutput(std::ostream& bitstreamFile, Int iNumEncoded, const std::list<AccessUnit>& accessUnits)
+#endif
 {
   Int i;
   
+#if H_MV
   if( iNumEncoded > 0 )
   {
-    TComList<TComPicYuv*>::iterator iterPicYuvRec = !isDepth ? m_picYuvRec[iViewIdx]->end() : m_picYuvDepthRec[iViewIdx]->end();
-  
-    for ( i = 0; i < iNumEncoded; i++ )
-    {
-      --iterPicYuvRec;
-    }
-  
-    for ( i = 0; i < iNumEncoded; i++ )
-    {
-      TComPicYuv*  pcPicYuvRec  = *(iterPicYuvRec++);
-      if( !isDepth )
+    TComList<TComPicYuv*>::iterator iterPicYuvRec = m_picYuvRec[layerId]->end();
+#else
+  TComList<TComPicYuv*>::iterator iterPicYuvRec = m_cListPicYuvRec.end();
+  list<AccessUnit>::const_iterator iterBitstream = accessUnits.begin();
+#endif
+
+  for ( i = 0; i < iNumEncoded; i++ )
+  {
+    --iterPicYuvRec;
+  }
+  
+  for ( i = 0; i < iNumEncoded; i++ )
+  {
+    TComPicYuv*  pcPicYuvRec  = *(iterPicYuvRec++);
+#if H_MV
+      if (m_pchReconFileList[layerId])
       {
-        if (m_pchReconFileList[iViewIdx])
-        {
-          m_acTVideoIOYuvReconFileList[iViewIdx]->write( pcPicYuvRec, m_cropLeft, m_cropRight, m_cropTop, m_cropBottom );
-        }
-      }
-      else
-      {
-        if (m_pchDepthReconFileList[iViewIdx])
-        {
-          m_acTVideoIOYuvDepthReconFileList[iViewIdx]->write( pcPicYuvRec, m_cropLeft, m_cropRight, m_cropTop, m_cropBottom );
-        }
+        m_acTVideoIOYuvReconFileList[layerId]->write( pcPicYuvRec, m_confLeft, m_confRight, m_confTop, m_confBottom );
       }
     }
@@ -1381,37 +899,24 @@
     }
   }
-}
-
-
-TComPicYuv* TAppEncTop::xGetPicYuvFromView( Int iViewIdx, Int iPoc, Bool bDepth, Bool bRecon )
-{
-  TComPic*    pcPic = xGetPicFromView( iViewIdx, iPoc, bDepth);
-  TComPicYuv* pcPicYuv = NULL;
-
-  if (pcPic != NULL)
-  {
-    if( bRecon )
-    {
-      if ( pcPic->getReconMark() )
-      {
-        pcPicYuv = pcPic->getPicYuvRec();
-      }
-    }
-    else
-    {
-      pcPicYuv = pcPic->getPicYuvOrg();
-    }
-  };
-
-  return pcPicYuv;
-};
+#else
+    if (m_pchReconFile)
+    {
+      m_cTVideoIOYuvReconFile.write( pcPicYuvRec, m_confLeft, m_confRight, m_confTop, m_confBottom );
+    }
+
+    const AccessUnit& au = *(iterBitstream++);
+    const vector<UInt>& stats = writeAnnexB(bitstreamFile, au);
+    rateStatsAccum(au, stats);
+  }
+#endif
+}
 
 /**
  *
  */
-void TAppEncTop::rateStatsAccum(const AccessUnit& au, const std::vector<unsigned>& annexBsizes)
+void TAppEncTop::rateStatsAccum(const AccessUnit& au, const std::vector<UInt>& annexBsizes)
 {
   AccessUnit::const_iterator it_au = au.begin();
-  vector<unsigned>::const_iterator it_stats = annexBsizes.begin();
+  vector<UInt>::const_iterator it_stats = annexBsizes.begin();
 
   for (; it_au != au.end(); it_au++, it_stats++)
